% FILE: testGradienti.m
% Esegue il test 2D del
%  o metodo del gradiente, e
%  o metodo del gradiente coniugato

% pulizia variabili, schermo
close all; clear all; clc

% sistema lineare simm. e def. pos.
A = [8 4; 4 3]; xsol = [-2;6]; b = A*xsol;

% Punto iniziale
x0 = [1;0];

% Metodo del gradiente
[xg,xghist] = gradiente(A,b,x0,1e-8,100);

% Metodo del gradiente coniugato
[xc,xchist] = gradcon(A,b,x0,1e-8,100);

% Disegno andamento della soluzione
funz = 'Z = 4.*X.^2+4.*X.*Y+3./2.*Y.^2-8.*X-10.*Y;';
X = xghist(1,:); Y = xghist(2,:); eval(funz); levels = Z;
[X,Y] = meshgrid(-6:0.1:2,-1:0.1:12); eval(funz);
figure;
contour(X,Y,Z,levels,'k');
hold on;
for i=1:size(xghist,2)-1
   line([xghist(1,i),xghist(1,i+1)],...
      [xghist(2,i),xghist(2,i+1)]);
   plot(xghist(1,i),xghist(2,i),'b*');
end
plot(xsol(1),xsol(2),'r*');
hold off;
title('metodo del gradiente');

% Disegno andamento della soluzione
funz = 'Z = 4.*X.^2+4.*X.*Y+3./2.*Y.^2-8.*X-10.*Y;';
X = xchist(1,:); Y = xchist(2,:); eval(funz); levels = Z;
[X,Y] = meshgrid(-6:0.1:2,-1:0.1:12); eval(funz);
figure;
contour(X,Y,Z,levels,'k');
hold on;
for i=1:size(xchist,2)-1
   line([xchist(1,i),xchist(1,i+1)],..
   [xchist(2,i),xchist(2,i+1)]);
   plot(xchist(1,i),xchist(2,i),'b*');
end
plot(xsol(1),xsol(2),'r*');
hold off;
title('metodo del gradiente coniugato');
